#!/usr/bin/python
# -*- coding: utf-8 -*-

xmlns="http://asp.mexmat.net/xmlns/ssx"

__ssx_xml_header = """<?xml version='1.0' encoding='utf-8'?>"""
__ssx_test_string = """
<ssx:body xmlns="http://www.w3.org/1999/xhtml" xmlns:ssx="%s">
	<ssx:title>Тестовый документ</ssx:title>
	<ssx:css href='test.css'/>
	<ssx:error><p>какая-то ошибка</p></ssx:error>
	<ssx:meta>метаинфа</ssx:meta>
</ssx:body>
""" % xmlns

def cgi_args():
	from os import environ
	return environ.get("QUERY_STRING", "")

def ssx_qs(args):
	if not args:
		return None
	from cgi import parse_qs
	return parse_qs(args, keep_blank_values = True, strict_parsing = True)

class QueryObj:
	def __init__(self, qs = None):
		self.qs = qs
	def get(self, what, default = None):
		try:
			return self.qs[what][0]
		except Exception,e:
			return default

def xmlq(s, relaxed = False):
	if not s: return ''
	if not getattr(s, "replace", None):
		s = str(s)
	s = str(s)
	s = s.replace('<', '&lt;')
	s = s.replace('&', '&amp;')
	if relaxed: return s
	s = s.replace('\'', '&#39;')
	s = s.replace('"', '&quot;')
	return s

class SSXRedirect(Exception):
	def __init__(self, url):
		self.url = url 

class SSXBareXML(Exception):
	def __init__(self, xml):
		self.xml = xml 

class SSXML:
	SSXRedirect = SSXRedirect
	def __init__(self, empty = False):
		if not empty:
			self.body = "<?xml version='1.0' encoding='utf-8'?>\n"
		else:
			self.body = ""
		self.stack = []
	def push(self, tag, attr=""):
		self.body += "<"+tag+" "+attr+">"
		self.stack.append(tag)
	def pop(self, tag=""):
		while len(self.stack):
			tmp = self.stack.pop()
			self.body += "</"+tmp+">\n"
			if (tag == "" or tag == tmp):
				break
	def data(self, data):
		self.body += data;
	def __text(self):
		if len(self.stack):
			self.pop(self.stack[0])
		return self.body
	def xml(self, xi = False):
		import libxml2
		_x = libxml2.parseDoc(self.__text())
		if not xi: return _x
		_x.xincludeProcess()
		return _x
	def text(self, xi = False):
		if not xi:
			return self.__text()
		import StringIO
		import libxml2
		_x = self.xml(xi = xi)
		sio = StringIO.StringIO()
		buf = libxml2.createOutputBuffer(sio, 'UTF-8')
		_x.saveFileTo(buf, 'UTF-8')
		_x.freeDoc()
		return sio.getvalue()

	__str__ = text

class SSXSLT:
	SSXRedirect = SSXRedirect
	import libxml2
	import libxslt

	def __init__(self, path):
		self.path = path 
		xsltdoc = self.libxml2.parseFile(path)
		if not xsltdoc:
			raise RuntimeError("Unable to parse XML from %s" % path)
		self.__xslt = self.libxslt.parseStylesheetDoc(xsltdoc)
		if not self.__xslt:
			raise RuntimeError("Unable to load XSLT from %s" % path)
	def __del__(self):
		if self.__xslt:
			self.__xslt.freeStylesheet()
		if self.__xml:
			self.__xml.freeDoc()
		if self.__result:
			self.__result.freeDoc()
	def xslt(self, text = None, xml = None):
		if xml:
			self.__xml = xml
		elif text:
			self.__xml = self.libxml2.parseDoc(text)
		else:
			raise RuntimeError("Either XML or text representation must be supplied")
		self.__result = self.__xslt.applyStylesheet(self.__xml, None)
		return self.__xslt.saveResultToString(self.__result)
